import { Compiler, NgModuleFactory } from '@angular/core';
/**
 * Configuration for NgModuleLoader.
 * token.
 *
 * @experimental
 */
export declare abstract class NgModuleLoaderConfig {
    /**
     * Prefix to add when computing the name of the factory module for a given module name.
     */
    factoryPathPrefix: string;
    /**
     * Suffix to add when computing the name of the factory module for a given module name.
     */
    factoryPathSuffix: string;
}
/**
 * NgModuleFactoryLoader that uses SystemJS to load NgModuleFactory
 */
export declare class NgModuleLoader {
    private _compiler;
    private _config;
    constructor(_compiler: Compiler, config?: NgModuleLoaderConfig);
    load(modulePath: string, ngModuleExport: string): Promise<NgModuleFactory<any>>;
}
